PROGRAM CUBUS;
(* nach NJ 5/83 S.6 *)
{ANPASSUNG BILDPUFFER AUF FEST E000 FUER AC1}
VAR X1,Y1,IDATA,I,SX,SY,X,Y,Z,X1A,Y1A: INTEGER;
    D,SCALE,RHO,THETA,PHI,S1,C1,S2,C2: REAL;
    C: STRING[1];
    BILD: ARRAY[0..50] OF INTEGER;
    MIT_ANIMAT: BOOLEAN;
PROCEDURE CLEARBUFFER;
CODE $21,$FF,$EF,$36,$20,$54,$5D,$1B,$01,$00,$08,$ED,$B8,$C9;
PROCEDURE COPYBUFFER;
CODE $21,$FF,$EF,$11,$FF,$17,$01,$00,$08,$ED,$B8,$C9;

PROCEDURE ANIMAT(EIN: BOOLEAN);
CONST PLOTADR=$1A00;  {MODIF. PLOT-ADRESSE}
VAR A: INTEGER;
BEGIN
   IF EIN THEN BEGIN
     MEM[PLOTADR  ]:=$FF; MEM[PLOTADR+1]:=$EF; END
   ELSE BEGIN
     MEM[PLOTADR  ]:=$FF; MEM[PLOTADR+1]:=$17; END;
END;
PROCEDURE LINE(X0,Y0,X1,Y1,Z1: INTEGER);
VAR I,DX,DY,D,AX,AY,BX,BY: INTEGER;
BEGIN
   DX:=X1-X0; DY:=Y1-Y0; BX:=0; AY:=0; AX:=1; BY:=1;
   IF DX<0 THEN BEGIN AX:=-1; DX:=-DX END;
   IF DY<0 THEN BEGIN BY:=-1; DY:=-DY END;
   IF DX<DY THEN BEGIN
     I:=DX; DX:=DY; DY:=I; BX:=AX; AX:=0; AY:=BY; BY:=0;
   END;
   D:=DX SHIFT -1;
   FOR I:=0 TO DX DO BEGIN
      PLOT(X0,Y0,Z1);
      X0:=X0+AX; Y0:=Y0+AY; D:=D+DY;
      IF D>DX THEN BEGIN
         D:=D-DX; X0:=X0+BX; Y0:=Y0+BY;
      END;
   END;
   X1A:=X1; Y1A:=Y1;
END;
PROCEDURE PROJ(X,Y,Z: INTEGER; VAR SX,SY: INTEGER);
VAR XE,YE,ZE: REAL;
BEGIN
   XE:=-X*S1+Y*C1; YE:=-X*C1*C2-Y*S1*C2+Z*S2;
   ZE:=-X*S2*C1-Y*S2*S1-Z*C2+RHO;
   SX:=ROUND(D*XE/ZE)+64; SY:=45-ROUND(D*YE/ZE);
   SY:=(SY*11) DIV 16;
END;
PROCEDURE DATAREAD(VAR X,Y,Z: INTEGER);
BEGIN
   X:=BILD[IDATA  ]; Y:=BILD[IDATA+1];
   Z:=BILD[IDATA+2]; IDATA:=IDATA+3;
END;
PROCEDURE RESTORE;
BEGIN
   IDATA:=0;
END;

BEGIN
   INIT BILD TO 1,1,1,1,-1,1,-1,-1,1,-1,1,1,
                1,1,1,1,1,-1,1,-1,-1,
                -1,-1,-1,-1,1,-1,1,1,-1,
                1,-1,1,1,-1,-1,-1,-1,1,
                -1,-1,-1,-1,1,1,-1,1,-1;
   RHO:=10.0; THETA:=0.0; D:=255; PHI:=1.3;
   WRITE(CHR(12),' Mit Plotpuffer? (J) ');
   READ (C); WRITE(CHR(12));
   MIT_ANIMAT:=C='J';
   IF MIT_ANIMAT THEN ANIMAT(TRUE);
   REPEAT
      IF MIT_ANIMAT THEN CLEARBUFFER;
      S1:=SIN(THETA); C1:=COS(THETA);
      S2:=SIN(PHI);   C2:=COS(PHI);
      RESTORE;
      DATAREAD(X,Y,Z); PROJ(X,Y,Z,X1A,Y1A);
      IF NOT MIT_ANIMAT THEN WRITE(CHR(12));
      FOR I:=1 TO 11 DO BEGIN
         DATAREAD(X,Y,Z); PROJ(X,Y,Z,SX,SY);
         LINE(X1A,Y1A,SX,SY,1);
      END;
      FOR I:=1 TO 2 DO BEGIN
         DATAREAD(X,Y,Z); PROJ(X,Y,Z,X1A,Y1A);
         DATAREAD(X,Y,Z); PROJ(X,Y,Z,SX,SY);
         LINE(X1A,Y1A,SX,SY,1);
      END;
      THETA:=THETA+0.1;
      IF MIT_ANIMAT THEN COPYBUFFER
      {ELSE FOR I:=1 TO 20000 DO;}
   UNTIL KEYBOARD;
   IF MIT_ANIMAT THEN ANIMAT(FALSE);
END.
